<template>
  <div>
    <div class="gva-form-box">
      <el-form :model="formData" ref="elFormRef" label-position="right" :rules="rule" label-width="80px">
        <el-form-item label="课程:" prop="cid">
          <el-input v-model.number="formData.cid" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="活动名称:" prop="actionName">
          <el-input v-model="formData.actionName" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="活动开始时间:" prop="actionStart">
          <el-date-picker v-model="formData.actionStart" type="date" placeholder="选择日期" :clearable="true"></el-date-picker>
        </el-form-item>
        <el-form-item label="活动结束时间:" prop="actionEnd">
          <el-date-picker v-model="formData.actionEnd" type="date" placeholder="选择日期" :clearable="true"></el-date-picker>
        </el-form-item>
        <el-form-item label="上下线:" prop="isShow">
          <el-switch v-model="formData.isShow" active-color="#13ce66" inactive-color="#ff4949" active-text="是" inactive-text="否" clearable ></el-switch>
        </el-form-item>
        <el-form-item label="二维码:" prop="qr">
          <el-input v-model="formData.qr" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="save">保存</el-button>
          <el-button type="primary" @click="back">返回</el-button>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script>
export default {
  name: 'CourseAction'
}
</script>

<script setup>
import {
  createCourseAction,
  updateCourseAction,
  findCourseAction
} from '@/api/courseAction'

// 自动获取字典
import { getDictFunc } from '@/utils/format'
import { useRoute, useRouter } from "vue-router"
import { ElMessage } from 'element-plus'
import { ref, reactive } from 'vue'
const route = useRoute()
const router = useRouter()

const type = ref('')
const formData = ref({
            cid: 0,
            actionName: '',
            actionStart: new Date(),
            actionEnd: new Date(),
            isShow: false,
            qr: '',
        })
// 验证规则
const rule = reactive({
               actionName : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               actionStart : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               actionEnd : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
})

const elFormRef = ref()

// 初始化方法
const init = async () => {
 // 建议通过url传参获取目标数据ID 调用 find方法进行查询数据操作 从而决定本页面是create还是update 以下为id作为url参数示例
    if (route.query.id) {
      const res = await findCourseAction({ ID: route.query.id })
      if (res.code === 0) {
        formData.value = res.data.recourseAction
        type.value = 'update'
      }
    } else {
      type.value = 'create'
    }
}

init()
// 保存按钮
const save = async() => {
      elFormRef.value?.validate( async (valid) => {
         if (!valid) return
            let res
           switch (type.value) {
             case 'create':
               res = await createCourseAction(formData.value)
               break
             case 'update':
               res = await updateCourseAction(formData.value)
               break
             default:
               res = await createCourseAction(formData.value)
               break
           }
           if (res.code === 0) {
             ElMessage({
               type: 'success',
               message: '创建/更改成功'
             })
           }
       })
}

// 返回按钮
const back = () => {
    router.go(-1)
}

</script>

<style>
</style>
